////////  基础函数

/**
 * 判断是不是android环境
 */
var isAndroid = navigator.userAgent.match(/(Android);?[\s\/]+([\d.]+)?/);

/**
 * 在String原型链上增加模板方法
 */ 
String.prototype.sgeRender = function (context) {
  return this.replace(/{{(.*?)}}/g, (match, key) => context[key.trim()]);
};

/**
 * 在String原型链上增加模板方法
 */ 
var unitConvert= function(num) {
	if((+num) ==0)return "0";
	if(+num < 10000)return num;
	var moneyUnits = ["", "万", "亿", "万亿"]
	var dividend = 10000
	var curentNum = num;
	var curentUnit = moneyUnits[0]
	for (var i = 0; i < moneyUnits.length; i++) {
		curentUnit = moneyUnits[i]
		if (strNumSize(curentNum) < 5) {
			break;
		}
		curentNum = curentNum / dividend
	}
	var m = {
		num: 0,
		unit: ""
	}
	m.unit = curentUnit;
	m.num = m.unit==""?curentNum:curentNum.toFixed(1);//小数点后保留1位
	return m.num+m.unit;
}

/**
 * 在String原型链上增加模板方法
 */
function strNumSize(tempNum) {
	var stringNum = tempNum.toString();
	var index = stringNum.indexOf(".");
	var newNum = stringNum
	if (index != -1) {
		newNum = stringNum.substring(0, index)
	}
	return newNum.length
}

///////  基础变量
var MY_SWIPER;//轮播对象
var TOPICS_ARRAY;//全局变量存储话题数组，用于投票后更新话题内容
var LAST_PENDING_TIME;//进入详情页面
//app端的滑动值
var TOUCH_SLOP = 0;
//初次按下时的x, y轴值
var LAST_TOUCH_CLIENT_X, LAST_TOUCH_CLIENT_Y;
//是否处于滑动中
var IS_BEING_DRAG = false;

var SGE = {
	config:{
		ENABLE_LOCAL_TEST :false, //本地测试开关,注意，非本地测试环境需要设置为false
		ENABLE_DEBUG :false,
		serviceUrl : ""
	}
};

///////  事件处理
SGE.eventLoop = {};
SGE.on = function (eventName, handler) {
    SGE.eventLoop[eventName] = handler;
}

var global = this;
global.onNativeEvent = function (event) {
	var _event;
	if (typeof event == "string") {
		_event = JSON.parse(event);
    }else {
		_event = event;
	}
    var _eh = SGE.eventLoop[_event.uri];
    if (_eh != undefined) {
        _eh.call(this, _event);
    }
}

dsBridge.register('onNativeEvent',function(arg){
	arg[1] = arg[1][0];
	onNativeEvent(arg);
});
function wkCallNativeForward(arg){
	var _res = dsBridge.call('forward',arg);
	return _res == null ? "" : _res;
}

//监听初始化事件，目前只是IOS会发布此事件
SGE.on('init', function (event) {
	SGE.init();
});

//监听换肤事件
SGE.on('setMainColor', function (event) {
	var theme = event.params[0].theme;//bright|dark
	if(theme == "dark"){
		//swiper-container
		$("body").addClass("swiper-container-dark");
	}else {
		$("body").removeClass("swiper-container-dark");
	}
});

//监听刷新数据事件
SGE.on('refreshH5TopicsData', function (event) {
	__getData(__getDataCallback);
});

//////////  公开函数
/**
* js附值,在web加载完成时将android的滑动单位值传给js
*/
function initTouchSlop(appTouchSlop) {
    TOUCH_SLOP = appTouchSlop;
}

/**
 * 初始化函数
 */
SGE.init= function(){
    if( SGE.config.ENABLE_DEBUG ){
		var cdj = new VConsole();
	}
	this.config.serviceUrl = wkCallNativeForward(JSON.stringify({
		'uri':'demeter://sys-jdz'
	}))
	MY_SWIPER = new Swiper('.swiper-container', {
		slidesPerView: 'auto',
		speed: 400,
		spaceBetween: 15,
		pagination: {
			el: '.swiper-pagination',
		},
		on:{
            sliderMove: function(){
                if(isAndroid){
					IS_BEING_DRAG = true;
					wkCallNativeForward(JSON.stringify({
                        'uri':'demeter://disallow-Intercept',
                        params:{
                            disallow:"true"
                        }
                    }));
                }
            },
         },
		loop:false     // 是否循环播放
	});
	//刷新数据
	onNativeEvent({
		uri:"refreshH5TopicsData"
	})
	dealWithTouchEventEspicallyInAndroid();
}

/**
 * 进入话题详情页
*/
SGE.goTopicDetail = function(topic_id){
	var _now = new Date().getTime();
	if(null != LAST_PENDING_TIME && (_now - LAST_PENDING_TIME) < 3000){
		//离上一次点击进入详情的时间未超过3秒
		return;
	}
	LAST_PENDING_TIME = _now;
	// console.log("进入话题详情页");
	for(var i= 0;i< TOPICS_ARRAY.length; i++){
		var _entry = TOPICS_ARRAY[i];
		if( _entry.f_id == topic_id ){
			var _obj = {};
			var _params = {};
			for(var k in _entry){
				_params[k] = _entry[k];
			}
			_obj['uri'] = 'demeter://topic-detail';
			_obj['params'] = _params;
			return wkCallNativeForward(JSON.stringify(_obj));
		}
	}
}

/**
 * 投票
*/
SGE.doVote = function(evt,op,topic_id){
	evt.stopPropagation();
	var params = {
		f_topic_id:topic_id,
		f_topic_hold:op
	};
	var _callback = function(data){
		//遍历到那个id，然后更新之
		for(var i= 0;i< TOPICS_ARRAY.length; i++){
			var _entry = TOPICS_ARRAY[i];
			if( _entry.f_id == topic_id ){
				
				_entry.f_myself_vote = data.f_myself_vote;
				_entry.f_join_count = data.f_join_count;
				_entry.f_positive_rate = data.f_positive_rate;
				_entry.f_negatie_rate = data.f_negatie_rate;
				_entry.f_positive = data.f_positive;
				_entry.f_negatie = data.f_negatie;
				
				var _dom = __getHTMLFragmentByEntry(_entry,TOPICS_ARRAY.length === 1);
				$("#sge_topic_"+topic_id).replaceWith(_dom);
			}
		}
		if( SGE.config.ENABLE_LOCAL_TEST ){
			return;
		}
		//去提交积分
		$.ajax({
			url: SGE.config.serviceUrl + "/user/score/saveScore?" + Math.random(),
			headers: {
				Accept: "application/json; charset=utf-8",
				Authorization: __getToken()
			},
			data: {
				f_task_id: "erocs_vote_activity"
			},
			type: "post",
			success: function (data) {
				//不处理
			}
		});
	}
	if( SGE.config.ENABLE_LOCAL_TEST ){
		TEST_DATA_VOTE.f_id = topic_id;
		TEST_DATA_VOTE.f_myself_vote = op;
		_callback(TEST_DATA_VOTE);
		return;
	}
	
	if(__getToken() == ""){
		//跳转到登录页
		var _obj = {
			'uri': 'demeter://action-userlogin'
		}
		return wkCallNativeForward(JSON.stringify(_obj));
	}
	
	$.ajax({
		url: SGE.config.serviceUrl + "/user/topic/doTopicVote?" + Math.random(),
		headers: {
			Accept: "application/json; charset=utf-8",
			Authorization: __getToken()
		},
		data: params,
		type: "post",
		success: function (data) {
			var _d;
			if(typeof data == "string"){
				_d = JSON.parse(data);
			}else {
				_d = data;
			}
			if(null != _d){
				_callback(_d);
			}
		}
	});
	return;
}

//////////  私有方法
/**
 * 私有方法 
 * 获取本地token
 */
var __getToken = function(){
	var _obj = {
		'uri': 'demeter://sys-usertoken'
	}
	return wkCallNativeForward(JSON.stringify(_obj));

}

/**
 * 私有方法
 * 隐藏窗口
 */
var __hideWin = function(){
	var _obj = {
		'uri': 'demeter://topic-hottopic-hidden',
		params:{
			show:"hide"
		}
	}
	return wkCallNativeForward(JSON.stringify(_obj));
}

/**
 * 私有方法
 * 显示窗口
 */
var __showWin = function(single){
	var _obj = {
		'uri': 'demeter://topic-hottopic-hidden',
		params:{
			show: "show",
			single:single===true?'1':'0'//1是true,0是false
		}
	}
	return wkCallNativeForward(JSON.stringify(_obj));
}

/**
 * 私有方法
 * 获取“话题列表”数据
*/
var __getData= function(_getdata_callback){
	// console.log("__getdata")
	if( SGE.config.ENABLE_LOCAL_TEST ){
		_getdata_callback(TEST_DATA_QUERY);
		return;
	}
	var _url;
	if(__getToken() == ""){
		//无token数据，隐藏窗口并返回
		_url = SGE.config.serviceUrl + "/user/topic/queryTopicVoteNoLogin?" + Math.random();
	}else {
		_url = SGE.config.serviceUrl + "/user/topic/queryTopicVote?" + Math.random();
	}
	$.ajax({
		url: _url,
		headers: {
			Accept: "application/json; charset=utf-8",
			Authorization: __getToken()
		},
		type: "get",
		success: function (data) {
			var _d;
			if(typeof data == "string"){
				_d = JSON.parse(data);
			}else {
				_d = data;
			}
			if(null != _d && $.isArray(_d)==true && _d.length> 0){
				__showWin(_d.length === 1);
				_getdata_callback(_d);
			}else {
				//无数据，隐藏窗口
				__hideWin();
			}
		}
	});
}

/**
 * 私有方法
 * 取数据的回调函数
 * 改为用append方式
*/
var __getDataCallback = function(data){
	//取到数据后，将loading去除
	var topic_dom = [];
	TOPICS_ARRAY = data;
	
	for(var i= 0;i< data.length; i++){
		var _entry = data[i];
		var _dom = __getHTMLFragmentByEntry(_entry,data.length === 1);
		topic_dom.push( _dom );
	}
	
	//$("#swiper-container .swiper-wrapper").html(topic_dom);
	//MY_SWIPER.update();
	// MY_SWIPER.removeAllSlides();
	//下面这句是为解决出现重复slide的BUG，因为removeALLSlides不能把数据全部删除，故增加强制清空dom操作。
	$("#swiper-container .swiper-wrapper").html('');
	MY_SWIPER.appendSlide(topic_dom);
}

/**
 * 私有方法
 * 根据话题信息生成话题的HTML片断
 * @single 是否只有一个slide，如果只有一个slide则全屏此slide
*/
function __getHTMLFragmentByEntry(_entry,single){
	var _topic_html= "";
	var _style_fragment = (single ? "width:97%;" : "");
	if (single) {
		$(".swiper-pagination").hide();
	} else {
		$(".swiper-pagination").show();
	}
	var topic_voted_tpl = 
		"<div class='swiper-slide'  id='sge_topic_{{f_id}}' style='"+_style_fragment+"margin-right: 15px;' onclick='SGE.goTopicDetail({{f_id}})'>\
			<div class='topicItem {{f_type_class}}'>\
				<div class='topic'>\
					<div class='hotTopic am-flex'>\
						<div class='am-flex-cell' style='height:.16rem'>{{f_type_title}}</div>\
						<span class='arrow'></span>\
					</div>\
					<h2 class='topicTitle'>{{f_topic_title}}</h2>\
					<div class='topicCount'>{{f_description}}</div>\
						{{vote_info}}\
						{{rate_info}}\
					<div class='am-flex topicMsg'>\
						<span>{{f_join_count}}人参与</span>\
						<span class='am-flex-cell'>{{f_start_time}} 至 {{f_end_date}}</span>\
					</div>\
				</div>\
			</div>\
		</div>";

	var topic_unvoted_tpl =
		"<div class='swiper-slide' id='sge_topic_{{f_id}}' style='"+_style_fragment+"margin-right: 15px;' onclick='SGE.goTopicDetail({{f_id}})' >\
			<div class='topicItem {{f_type_class}}'>\
				<div class='topic'>\
					<div class='hotTopic am-flex'>\
						<div class='am-flex-cell' style='height:.16rem'>{{f_type_title}}</div>\
						<span class='arrow'></span>\
					</div>\
					<h2 class='topicTitle'>{{f_topic_title}}</h2>\
					<div class='topicCount'>{{f_description}}</div>\
					<div class='am-flex am-pt-20'>\
						<a href='#' class='btnRed' onclick='SGE.doVote(event,1,{{f_id}})'>{{f_topic_positive}}</a>\
						<a href='#' class='btnBlue' onclick='SGE.doVote(event,2,{{f_id}})'>{{f_topic_negative}}</a>\
					</div>\
					<div class='am-flex topicMsg'>\
						<span>{{f_join_count}}人参与</span>\
						<span class='am-flex-cell'>{{f_start_time}} 至 {{f_end_date}}</span>\
					</div>\
				</div>\
			</div>\
		</div>";
	
	//处理rate_info
	if(_entry.f_enabled == "0"){
		//已结束的情况
		_entry.rate_info= "<div class='vote_finish'></div><div class='topicPro am-flex' style='width:85%;'>";
	}else {
		//未结束
		_entry.rate_info= "<div class='topicPro am-flex'>";
	}
	if(_entry.f_positive_rate == "100"){
		//正方100%
		_entry.rate_info+=
			"<span class='positive_num' style='color:#FB6C6A;margin-right:.05rem'>"+unitConvert(_entry.f_positive)+ "票"+"</span>"+
			"<div class='rate_bar' style='flex-grow:1;display: flex;'>"+
				"<span class='rate_bar_positive' style='padding-left: .1rem;height: .16rem;line-height: .16rem;display: flex;align-items: center;width:100%;color: #fff;border-top-left-radius: .16rem;border-bottom-left-radius: .16rem;border-top-right-radius: .16rem;border-bottom-right-radius: .16rem;'>100%</span>"+
			"</div>"+
			"<span class='oppose_num' style='color: #6B75FC;margin-left:.05rem'>0票</span>"+
		"</div>";
	}else if(_entry.f_positive_rate == "0"){
		if(_entry.f_negatie_rate == "0"){
			//反方也是0
			_entry.rate_info+=
			"<span class='positive_num' style='color:#FB6C6A;margin-right:.05rem'>0票</span>"+
			"<div class='rate_bar' style='flex-grow:1;display: flex;'>"+
				"<div class='rate_bar_positive' style='padding-left: .1rem;height: .16rem;line-height: .16rem;display: flex;align-items: center;width:50%;color: #fff;border-top-left-radius: .16rem;border-bottom-left-radius: .16rem;'><span>0%</span></div>"+
				"<span style='width:4px;display: inline-block;'></span>"+
				"<div class='rate_bar_oppose' style='padding-right: .1rem;height: .16rem;line-height: .16rem;display: flex;align-items: center;justify-content: flex-end;width:50%;color: #fff;border-top-right-radius: .16rem;border-bottom-right-radius: .16rem;text-align:right;'><span>0%</span></div>"+
			"</div>"+
			"<span class='oppose_num' style='color: #6B75FC;margin-left:.05rem'>0票</span>"+
		"</div>";
		}else {
			//反方100%
			_entry.rate_info+=
				"<span class='positive_num' style='color:#FB6C6A;margin-right:.05rem'>0票</span>"+
				"<div class='rate_bar' style='flex-grow:1;display: flex;'>"+
					"<span class='rate_bar_oppose' style='padding-right: .1rem;height: .16rem;line-height: .16rem;display: flex;align-items: center;justify-content: flex-end;width:100%;color: #fff;border-top-left-radius: .16rem;border-bottom-left-radius: .16rem;border-top-right-radius: .16rem;border-bottom-right-radius: .16rem;text-align:right;'>100%</span>"+
				"</div>"+
				"<span class='oppose_num' style='color: #6B75FC;margin-left:.05rem'>"+unitConvert(_entry.f_negatie)+ "票"+"</span>"+
			"</div>";
		}
	}else {
		//其他情况
		var _positive_rate = _entry.f_positive_rate;
		var _negatie_rate = _entry.f_negatie_rate;
		var _positive = unitConvert(_entry.f_positive)+"票";
		var _negatie = unitConvert(_entry.f_negatie)+"票";
		var _zuida_chidu = 68;
		var _zuixiao_chidu = 28;
		if(_positive_rate.length > 4){
			//上千票的情况
			_zuida_chidu = 60;
			_zuixiao_chidu = 36;
		}
		if(_entry.f_positive_rate > _zuida_chidu){
			_positive_rate = _zuida_chidu;
			_negatie_rate = _zuixiao_chidu;
		}else if(_entry.f_positive_rate < _zuixiao_chidu){
			_positive_rate = _zuixiao_chidu;
			_negatie_rate = _zuida_chidu;
		}else {
			//_positive_rate -= 2;
			//_negatie_rate -= 2;
		}
		_entry.rate_info+=
			"<span class='positive_num' style='color:#FB6C6A;margin-right:.05rem'>"+_positive+"</span>"+
			"<div class='rate_bar' style='flex-grow:1;display: flex;'>"+
				"<div class='rate_bar_positive' style='padding-left: .1rem;height: .16rem;line-height: .16rem;display: flex;align-items: center;width:"+_positive_rate+"%;color: #fff;border-top-left-radius: .16rem;border-bottom-left-radius: .16rem;'><span>"+_entry.f_positive_rate+"%</span></div>"+
				"<span style='width:4px;display: inline-block;'></span>"+
				"<div class='rate_bar_oppose' style='padding-right: .1rem;height: .16rem;line-height: .16rem;display: flex;align-items: center;justify-content: flex-end;width:"+_negatie_rate+"%;color: #fff;border-top-right-radius: .16rem;border-bottom-right-radius: .16rem;text-align:right;'><span>"+_entry.f_negatie_rate+"%</span></div>"+
			"</div>"+
			"<span class='oppose_num' style='color: #6B75FC;margin-left:.05rem'>"+_negatie+"</span>"+
		"</div>";
	}
	
	//处理vote_info
	if(_entry.f_enabled == "0" || _entry.f_myself_vote == "1" || _entry.f_myself_vote == "2"){
		//已投的，/*20190515新增需求*/和已结束的，显示投票结果
		_entry.vote_info = (_entry.f_enabled == "0"?"<div class='am-flex' style='width:85%;padding-top: .15rem;'>":"<div class='am-flex' style='padding-top: .15rem;'>");
		if(_entry.f_myself_vote == "1"){
			//已投正方
			_entry.vote_info+= 
				"<div class='am-flex-cell topicAgree'>"+
					"<span class='agree_text'>已选\"" +_entry.f_topic_positive+ "\"</span>"+
					//"<input type='radio' class='inputAgree' id='radio1' name='radio1' /><label for='radio1'><span class='agreement'>已选\"" +_entry.f_topic_positive+ "\"</span></label>"+
				"</div>"+
				"<div class='am-flex-cell topicOppose'>" +_entry.f_topic_negative+ "</div>"+
			"</div>";
			if( _entry.f_topic_type == "1" ){
				//话题
				_entry.f_type_class = "topicTemplate1";
			}else {
				//猜涨跌
				_entry.f_type_class = "upDown1";
			}		
		}else if(_entry.f_myself_vote == "2"){
			//已投反方
			_entry.vote_info+= 
				"<div class='am-flex-cell topicAgree'>" +_entry.f_topic_positive+ "</div>"+
				"<div class='am-flex-cell topicOppose'>"+
					"<span class='disagree_text'>已选\"" +_entry.f_topic_negative+ "\"</span>"+
					//"<input type='radio' class='inputOppose' id='radio1' name='radio1' /><label for='radio1'><span class='agreement'>已选\"" +_entry.f_topic_negative+ "\"</span></label>"+
				"</div>"+
			"</div>";
			if( _entry.f_topic_type == "1" ){
				//话题
				_entry.f_type_class = "topicTemplate2";
			}else {
				//猜涨跌
				_entry.f_type_class = "upDown2";
			}
		}else {
			//自己未投票的情况
			_entry.vote_info+= 
				"<div class='am-flex-cell topicAgree'>" +_entry.f_topic_positive+ "</div>"+
				"<div class='am-flex-cell topicOppose'>" +_entry.f_topic_negative+ "</div>"+
			"</div>";
			if( _entry.f_topic_type == "1" ){
				//话题
				_entry.f_type_class = "topicTemplate";
			}else {
				//猜涨跌
				_entry.f_type_class = "upDown";
			}
		}
		_topic_html = topic_voted_tpl.slice(0);
	}else {
		//未投
		_topic_html = topic_unvoted_tpl.slice(0);
		if( _entry.f_topic_type == "1" ){
			//话题
			_entry.f_type_class = "topicTemplate";
		}else {
			//猜涨跌
			_entry.f_type_class = "upDown";
		}
	}
	if( _entry.f_topic_type == "1" ){
		//话题
		_entry.f_type_title = "<span>#</span>热议话题";
	}else {
		//猜涨跌
		_entry.f_type_title = "<img src='images/icon4.png' alt='' />猜涨跌";
	}
	//参与人数做单位转换
	_entry.f_join_count = unitConvert(_entry.f_join_count);
	return _topic_html.sgeRender(_entry);
}

/**
 * 私有方法
 * swiper事件处理，只是安卓需要
 *
 */
function dealWithTouchEventEspicallyInAndroid(){
	if(!isAndroid){
		return;
	}
	$('.swiper-container').on('touchstart touchmove touchend touchcancel' , function(event) {
		var touch = event.originalEvent.targetTouches[0];
		switch (event.type) {
			case "touchstart":
				LAST_TOUCH_CLIENT_X = touch.clientX;
				LAST_TOUCH_CLIENT_Y = touch.clientY;
				IS_BEING_DRAG = false;
				wkCallNativeForward(JSON.stringify({
					'uri':'demeter://disallow-Intercept',
					params:{
						disallow:"true"
					}
				}));
				// Demeter.forward(JSON.stringify({
				// 	'uri':'demeter://disallow-Intercept',
				// 	params:{
				// 		disallow:"true"
				// 	}
				// }));
				break;
			case "touchmove":
				if (!IS_BEING_DRAG) {
					var xDiff = Math.abs(touch.clientX - LAST_TOUCH_CLIENT_X);
					var yDiff = Math.abs(touch.clientY - LAST_TOUCH_CLIENT_Y);
					if (xDiff >= TOUCH_SLOP) {
						IS_BEING_DRAG = true;
					} else if(yDiff > TOUCH_SLOP) {
						//产生app纵向滑动,父控件不强制请求放行事件,这段逻辑主要是不影响外层垂直滑动控件的滑动
						//js端控制滑动与app端的标准不一样,所以结合上面的onSliderMove:function方法来判断
						//如果H5端控件已经产生滑动时则必须请求父控件放行事件
						//如果有些开源控件没有类似onSliderMove方法时,只需提供控件是否产生滑动就行,原理都是一样
						IS_BEING_DRAG = true;
						wkCallNativeForward(JSON.stringify({
							'uri':'demeter://disallow-Intercept',
							params:{
								disallow:"false"
							}
						}));
					}
				}
				break;
			case "touchend":wkCallNativeForward(JSON.stringify({
				'uri':'demeter://disallow-Intercept',
				params:{
					disallow:"false"
				}
			}))
				break;
		}
	});
}
